<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="围栏名称" prop="fenceName">
        <el-input
          v-model="queryParams.fenceName"
          placeholder="请输入围栏名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="围栏类型" prop="fenceType">
        <el-select v-model="queryParams.fenceType" placeholder="请选择围栏类型" clearable size="small">
          <el-option
            v-for="dict in fenceAlarmTypeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="围栏状态" prop="state">
        <el-select v-model="queryParams.state" placeholder="请选择围栏状态" clearable size="small">
          <el-option
            v-for="dict in statusOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['vehicles:sysCorpuscleFence:addSysCorpuscleFence']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['vehicles:sysCorpuscleFence:updSysCorpuscleFence']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['vehicles:sysCorpuscleFence:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['vehicles:sysCorpuscleFence:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
<!--    :formatter="statusFormat"-->
<!--    :formatter="fenceAlarmTypeFormat"-->
    <el-table v-loading="loading" :data="fenceList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="围栏名称" align="center" prop="fenceName" />
      <el-table-column label="围栏类型" align="center" prop="fenceType" >
      <template slot-scope="scope">
        <dict-tag :options="dict.type.vehicle_fence_type" :value="scope.row.fenceType"/>
      </template>
      </el-table-column>
      <el-table-column label="围栏状态" align="state" prop="state">
      <template slot-scope="scope">
        <dict-tag :options="dict.type.yes_no" :value="scope.row.state"/>
      </template>
      </el-table-column>
      <el-table-column label="围栏位置" align="center" prop="fencePosition" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">

        <template slot-scope="scope">
          <el-button
            type="warning"
            class="el-icon-view"
            @click="lookFence(scope.row)"></el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="showFaultDraw(scope.row)"
          >绘制围栏</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['vehicle:fence:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['vehicle:fence:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改电子围栏对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-input v-show="false" v-model="form.id" />
        <el-form-item label="围栏名称" prop="fenceName">
          <el-input v-model="form.fenceName" placeholder="请输入围栏名称" />
        </el-form-item>
        <el-form-item label="围栏类型" prop="fenceType">
          <el-select v-model="form.fenceType" placeholder="请选择围栏类型">
            <el-option
              v-for="dict in fenceAlarmTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
<!--        <el-form-item label="围栏状态">-->
<!--          <el-radio-group v-model="form.state">-->
<!--            <el-radio-->
<!--              v-for="dict in statusOptions"-->
<!--              :key="dict.dictValue"-->
<!--              :label="parseInt(dict.dictValue)"-->
<!--            >{{dict.dictLabel}}</el-radio>-->
<!--          </el-radio-group>-->
<!--        </el-form-item>-->
        <el-form-item label="围栏状态：" prop="state">
          <el-radio-group v-model="form.state">
            <el-radio
              v-for="dict in dict.type.yes_no"
              :key="dict.value"
              :label="dict.value"
            >{{ dict.label }}
            </el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-drawer
      v-if="faultDrawStatus"
      :title="drawerTitle"
      :visible.sync="drawer"
      :direction="direction"
      :before-close="handleClose"
      size="100%">
      <fault-draw ref="faultDraw" v-if="faultDrawStatus" v-bind:id="fenceId" @handleClose="handleClose"></fault-draw>
    </el-drawer>
  </div>
</template>

<script>
import { listFence, getFence, delFence, addFence, updateFence } from "@/api/vehicle/fence";
import FaultDraw from "@/views/fence/AMAP/index.vue";
export default {
  name: "fence",
  dicts: ['sys_normal_disable','yes_no','vehicle_fence_type'],
  components: { FaultDraw },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 电子围栏表格数据
      fenceList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 围栏类型字典
      fenceAlarmTypeOptions: [],
      // 围栏状态字典
      statusOptions: [],
      // 查询参数
      queryParams: {
        // pageNum: 1,
        // pageSize: 10,
        fenceName: null,
        fenceType: null,
        state: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
      ,
      drawer: false,
      direction: 'rtl',
      drawerTitle:"",
      fenceId: "",
      faultDrawStatus:false,
    };
  },
  created() {
    this.getList();
    this.getDicts("vehicle_fence_type").then(response => {
      this.fenceAlarmTypeOptions = response.data;
    });
    this.getDicts("yes_no").then(response => {
      this.statusOptions = response.data;
    });
  },
  methods: {
    /** 查询电子围栏列表 */
    getList() {
      this.loading = true;
      listFence(this.queryParams).then(response => {
        this.fenceList = response.data;
        // this.total = response.data.total;
        this.loading = false;
        console.log("列表"+response.data)
      });
    },
    // 围栏类型字典翻译
    fenceAlarmTypeFormat(row, column) {
      return this.selectDictLabel(this.fenceAlarmTypeOptions, row.fenceAlarmType);
    },
    // 围栏状态字典翻译
    statusFormat(row, column) {
      return this.selectDictLabel(this.statusOptions, row.state);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        fenceName: null,
        fenceAlarmType: null,
        status: 0,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加电子围栏";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getFence(id).then(response => {
        this.form = response.data;
        console.log(response)
        this.open = true;
        this.title = "修改电子围栏";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          alert(this.form.id)
          if (this.form.id != null) {
            updateFence(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addFence(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除电子围栏编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return delFence(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('vehicles/sysCorpuscleFence/export', {
        ...this.queryParams
      }, `vehicle_fence.xlsx`)
    },
    lookFence(row){
      if (row.longitudeLatitude==null||row.longitudeLatitude==undefined||row.longitudeLatitude==''){
        this.$modal.msgError("请先设置电子围栏");
        return;
      }
      this.$router.push({
        path:'map',
        query:{id:row.id,longitudeLatitude:row.longitudeLatitude,open:0}
      })
    },
    showFaultDraw(row){
      this.drawer = true;
      this.drawerTitle = "绘制围栏：" + row.fenceName ;
      this.fenceId = row.id;
      this.faultDrawStatus = true;
    },
    handleClose(){
      this.drawer = false;
      this.faultDrawStatus = false;
    }
  }
};
</script>
